require 'sketchup.rb'

def getmaterials
	model = Sketchup.active_model
	sel = model.selection
	entities = model.active_entities
	materials = model.materials

	results = inputbox ["材质类型：", "模板边长："], ["贴图",1000.mm], ["贴图|颜色|全部",""], "获取材质   SketchUpBAR dota_"
	return if !results
	
	materialsname = []
	faces = []
	size = results[1]
	
	case results[0]
	when '贴图'
		materials.map { |m|
			if not m.materialType == 0
				materialsname << m.name
			end
		}
	when '颜色'
		materials.map { |m|
			if m.materialType == 0
				materialsname << m.name
			end
		}
	else
		materials.map { |m| materialsname << m.name}
	end

	if materialsname.length == 0
		UI.messagebox '未能找到所选类型的材质！'
		return nil
	end
	
	model.start_operation "获取材质"
	
	frame = entities.add_group
	i = 0
	o = 0
	width = size
	length = 0.mm
	materialsname.each{ |m|
		pts = []
		pts[0] = [length, width - size, 0]
		pts[1] = [length + size, width - size, 0]
		pts[2] = [length + size, 0 + width, 0]
		pts[3] = [length, width, 0]
		face = frame.entities.add_face pts
		face.material = m
		face.back_material = m
		i += 1
		o += 1
		width += size
		if i > 9
		i = 0
		length += size
		width = size
		end
	}
	
	model.commit_operation
	UI.messagebox '共获取 ' + o.to_s + ' 个材质！'
end

unless file_loaded?( File.basename(__FILE__) )
	UI.menu('Plugins').add_item( '获取材质' ) { getmaterials }
			path = Sketchup.find_support_file("Plugins/getmaterials")
  getmaterials_tb = UI::Toolbar.new("获取材质")
  cmd1 = UI::Command.new("获取材质") { getmaterials } 
  cmd1.small_icon = File.join(path,"icons/getmaterials24.png")
  cmd1.large_icon = File.join(path,"icons/getmaterials36.png")
  cmd1.tooltip = "获取材质"
  cmd1.status_bar_text = "快速获取场景中的材质并形成面片列表"
  getmaterials_tb.add_item(cmd1)
  getmaterials_tb.show
end
file_loaded( File.basename(__FILE__) )
